"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.LoginScreenBase=void 0;var _extends2=_interopRequireDefault(require("@babel/runtime/helpers/extends"));var _slicedToArray2=_interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));var _objectWithoutProperties2=_interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));var _react=_interopRequireWildcard(require("react"));var _WorkflowCard=require("../../components/WorkflowCard");var _WorkflowCardBody=require("../../components/WorkflowCard/WorkflowCardBody");var _components=require("../../components");var _reactNative=require("react-native");var _reactNativePaper=require("react-native-paper");var _reactNativeThemes=require("@brightlayer-ui/react-native-themes");var _useScreenDimensions2=require("../../hooks/useScreenDimensions");var _jsxFileName="/home/runner/work/blui-react-native-workflows/blui-react-native-workflows/login-workflow/src/screens/LoginScreen/LoginScreenBase.tsx";var _excluded=["usernameLabel","usernameTextFieldProps","usernameValidator","initialUsernameValue","passwordLabel","passwordTextFieldProps","passwordValidator","showRememberMe","rememberMeLabel","rememberMeInitialValue","onRememberMeChanged","loginButtonLabel","onLogin","showForgotPassword","forgotPasswordLabel","onForgotPassword","showSelfRegistration","selfRegisterButtonLabel","selfRegisterInstructions","onSelfRegister","showContactSupport","contactSupportLabel","onContactSupport","errorDisplayConfig","showCyberSecurityBadge","projectImage","header","footer"];function _getRequireWildcardCache(e){if("function"!=typeof WeakMap)return null;var r=new WeakMap(),t=new WeakMap();return(_getRequireWildcardCache=function _getRequireWildcardCache(e){return e?t:r;})(e);}function _interopRequireWildcard(e,r){if(!r&&e&&e.__esModule)return e;if(null===e||"object"!=typeof e&&"function"!=typeof e)return{default:e};var t=_getRequireWildcardCache(r);if(t&&t.has(e))return t.get(e);var n={__proto__:null},a=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var u in e)if("default"!==u&&Object.prototype.hasOwnProperty.call(e,u)){var i=a?Object.getOwnPropertyDescriptor(e,u):null;i&&(i.get||i.set)?Object.defineProperty(n,u,i):n[u]=e[u];}return n.default=e,t&&t.set(e,n),n;}var makeStyles=function makeStyles(isTablet){return _reactNative.StyleSheet.create({container:{flex:1},projectImageWrapper:{display:'flex',maxWidth:'100%',marginBottom:isTablet?24:16},inputFieldsWrapper:{display:'flex',flexDirection:'column',justifyContent:'center',alignItems:'center',width:'100%',marginVertical:isTablet?32:24},usernameWrapper:{width:'100%',marginVertical:isTablet?32:24},passwordWrapper:{width:'100%'},rememberMeLoginRowWrapper:{display:'flex',alignItems:'center',width:'100%',justifyContent:'center',flexDirection:'row',marginTop:isTablet?24:16,marginBottom:isTablet?32:24},rememberMeWrapper:{display:'flex',flex:1,alignItems:'center',flexDirection:'row'},loginButtonWrapper:{display:'flex',flex:1,justifyContent:'flex-end',flexDirection:'row'},rememberMeText:{display:'flex',flex:1},loginButton:{width:'100%'},forgotPasswordWrapper:{display:'flex',justifyContent:'center',alignContent:'center',alignItems:'center',marginBottom:isTablet?32:24},selfRegisterWrapper:{display:'flex',justifyContent:'center',alignItems:'center',flexDirection:'column',marginTop:4,alignContent:'center',marginBottom:isTablet?32:24},contactSupportWrapper:{display:'flex',justifyContent:'center',marginTop:4,alignContent:'center',alignItems:'center',marginBottom:isTablet?32:24},footerWrapper:{display:'flex',justifyContent:'center'},cyberSecurityBadgeWrapper:{display:'flex',justifyContent:'center',marginTop:2}});};var LoginScreenBase=exports.LoginScreenBase=function LoginScreenBase(props){var usernameLabel=props.usernameLabel,usernameTextFieldProps=props.usernameTextFieldProps,usernameValidator=props.usernameValidator,initialUsernameValue=props.initialUsernameValue,passwordLabel=props.passwordLabel,passwordTextFieldProps=props.passwordTextFieldProps,passwordValidator=props.passwordValidator,showRememberMe=props.showRememberMe,rememberMeLabel=props.rememberMeLabel,rememberMeInitialValue=props.rememberMeInitialValue,onRememberMeChanged=props.onRememberMeChanged,loginButtonLabel=props.loginButtonLabel,onLogin=props.onLogin,showForgotPassword=props.showForgotPassword,forgotPasswordLabel=props.forgotPasswordLabel,onForgotPassword=props.onForgotPassword,showSelfRegistration=props.showSelfRegistration,selfRegisterButtonLabel=props.selfRegisterButtonLabel,selfRegisterInstructions=props.selfRegisterInstructions,onSelfRegister=props.onSelfRegister,showContactSupport=props.showContactSupport,contactSupportLabel=props.contactSupportLabel,onContactSupport=props.onContactSupport,errorDisplayConfig=props.errorDisplayConfig,showCyberSecurityBadge=props.showCyberSecurityBadge,projectImage=props.projectImage,header=props.header,footer=props.footer,otherProps=(0,_objectWithoutProperties2.default)(props,_excluded);var theme=(0,_reactNativeThemes.useExtendedTheme)();var _useScreenDimensions=(0,_useScreenDimensions2.useScreenDimensions)(),isTablet=_useScreenDimensions.isTablet;var _React$useState=_react.default.useState(initialUsernameValue||''),_React$useState2=(0,_slicedToArray2.default)(_React$useState,2),username=_React$useState2[0],setUsername=_React$useState2[1];var _React$useState3=_react.default.useState(''),_React$useState4=(0,_slicedToArray2.default)(_React$useState3,2),password=_React$useState4[0],setPassword=_React$useState4[1];var _React$useState5=_react.default.useState(rememberMeInitialValue),_React$useState6=(0,_slicedToArray2.default)(_React$useState5,2),rememberMe=_React$useState6[0],setRememberMe=_React$useState6[1];var _React$useState7=_react.default.useState(false),_React$useState8=(0,_slicedToArray2.default)(_React$useState7,2),shouldValidateUsername=_React$useState8[0],setShouldValidateUsername=_React$useState8[1];var _React$useState9=_react.default.useState(false),_React$useState10=(0,_slicedToArray2.default)(_React$useState9,2),shouldValidatePassword=_React$useState10[0],setShouldValidatePassword=_React$useState10[1];var passwordField=(0,_react.useRef)(null);var _useState=(0,_react.useState)(usernameValidator?usernameValidator(username):true),_useState2=(0,_slicedToArray2.default)(_useState,2),isUsernameValid=_useState2[0],setIsUsernameValid=_useState2[1];var _useState3=(0,_react.useState)(passwordValidator?passwordValidator(password):true),_useState4=(0,_slicedToArray2.default)(_useState3,2),isPasswordValid=_useState4[0],setIsPasswordValid=_useState4[1];var _useState5=(0,_react.useState)(isUsernameValid===true?'':isUsernameValid),_useState6=(0,_slicedToArray2.default)(_useState5,2),usernameError=_useState6[0],setUsernameError=_useState6[1];var _useState7=(0,_react.useState)(isPasswordValid===true?'':isPasswordValid),_useState8=(0,_slicedToArray2.default)(_useState7,2),passwordError=_useState8[0],setPasswordError=_useState8[1];var defaultStyles=makeStyles(isTablet);var handleUsernameInputChange=(0,_react.useCallback)(function(value){setUsername(value);var validatorResponse=usernameValidator===null||usernameValidator===void 0?void 0:usernameValidator(value);setIsUsernameValid(typeof validatorResponse==='boolean'?validatorResponse:false);setUsernameError(typeof validatorResponse==='string'?validatorResponse:'');},[usernameValidator]);var handlePasswordInputChange=(0,_react.useCallback)(function(value){setPassword(value);var validatorResponse=passwordValidator===null||passwordValidator===void 0?void 0:passwordValidator(value);setIsPasswordValid(typeof validatorResponse==='boolean'?validatorResponse:false);setPasswordError(typeof validatorResponse==='string'?validatorResponse:'');},[passwordValidator]);var handleForgotPassword=function handleForgotPassword(){if(onForgotPassword)onForgotPassword();};var handleSelfRegister=function handleSelfRegister(){if(onSelfRegister)onSelfRegister();};var handleContactSupport=function handleContactSupport(){if(onContactSupport)onContactSupport();};var handleRememberMeChanged=function handleRememberMeChanged(value){if(onRememberMeChanged){onRememberMeChanged(value);setRememberMe(value);}};var isFormValid=function isFormValid(){return typeof isUsernameValid==='boolean'&&isUsernameValid&&typeof isPasswordValid==='boolean'&&isPasswordValid;};var handleLogin=function handleLogin(){if(isFormValid()&&onLogin)void onLogin(username,password,rememberMe);};var handleLoginSubmit=function handleLoginSubmit(){if(isFormValid()){handleLogin();}};return _react.default.createElement(_WorkflowCard.WorkflowCard,(0,_extends2.default)({testID:"blui-login-workflow-card"},otherProps,{__source:{fileName:_jsxFileName,lineNumber:224,columnNumber:9}}),_react.default.createElement(_WorkflowCardBody.WorkflowCardBody,{__source:{fileName:_jsxFileName,lineNumber:225,columnNumber:13}},header,_react.default.createElement(_reactNative.View,{style:defaultStyles.projectImageWrapper,testID:"blui-login-project-image-wrapper",__source:{fileName:_jsxFileName,lineNumber:227,columnNumber:17}},projectImage),_react.default.createElement(_components.ErrorManager,(0,_extends2.default)({},errorDisplayConfig,{__source:{fileName:_jsxFileName,lineNumber:231,columnNumber:17}}),_react.default.createElement(_reactNative.View,{style:defaultStyles.inputFieldsWrapper,testID:"blui-login-input-fields-wrapper",__source:{fileName:_jsxFileName,lineNumber:232,columnNumber:21}},_react.default.createElement(_reactNative.View,{style:defaultStyles.usernameWrapper,__source:{fileName:_jsxFileName,lineNumber:233,columnNumber:25}},_react.default.createElement(_reactNativePaper.TextInput,(0,_extends2.default)({testID:'blui-login-username-text-field',label:usernameLabel||'Username',value:username,error:shouldValidateUsername&&!isUsernameValid,autoCapitalize:"none",mode:"flat"},usernameTextFieldProps,{onChangeText:function onChangeText(e){(usernameTextFieldProps===null||usernameTextFieldProps===void 0?void 0:usernameTextFieldProps.onChangeText)&&usernameTextFieldProps.onChangeText(e);handleUsernameInputChange(e);},onSubmitEditing:function onSubmitEditing(e){(usernameTextFieldProps===null||usernameTextFieldProps===void 0?void 0:usernameTextFieldProps.onSubmitEditing)&&usernameTextFieldProps.onSubmitEditing(e);if(passwordField.current)passwordField.current.focus();},onBlur:function onBlur(e){(usernameTextFieldProps===null||usernameTextFieldProps===void 0?void 0:usernameTextFieldProps.onBlur)&&usernameTextFieldProps.onBlur(e);setShouldValidateUsername(true);},__source:{fileName:_jsxFileName,lineNumber:234,columnNumber:29}})),shouldValidateUsername&&!isUsernameValid&&_react.default.createElement(_reactNativePaper.HelperText,{type:"error",__source:{fileName:_jsxFileName,lineNumber:260,columnNumber:33}},usernameError)),_react.default.createElement(_reactNative.View,{style:defaultStyles.passwordWrapper,__source:{fileName:_jsxFileName,lineNumber:263,columnNumber:25}},_react.default.createElement(_components.PasswordTextField,(0,_extends2.default)({ref:passwordField,testID:'blui-login-password-text-field',label:passwordLabel||'Password',mode:"flat",value:password,error:shouldValidatePassword&&!isPasswordValid},passwordTextFieldProps,{onChangeText:function onChangeText(e){(passwordTextFieldProps===null||passwordTextFieldProps===void 0?void 0:passwordTextFieldProps.onChange)&&passwordTextFieldProps.onChange(e);handlePasswordInputChange(e);},onSubmitEditing:function onSubmitEditing(e){(passwordTextFieldProps===null||passwordTextFieldProps===void 0?void 0:passwordTextFieldProps.onSubmitEditing)&&passwordTextFieldProps.onSubmitEditing(e);handleLoginSubmit();},onBlur:function onBlur(e){(passwordTextFieldProps===null||passwordTextFieldProps===void 0?void 0:passwordTextFieldProps.onBlur)&&passwordTextFieldProps.onBlur(e);setShouldValidatePassword(true);},__source:{fileName:_jsxFileName,lineNumber:264,columnNumber:29}})),shouldValidatePassword&&!isPasswordValid&&_react.default.createElement(_reactNativePaper.HelperText,{type:"error",__source:{fileName:_jsxFileName,lineNumber:290,columnNumber:33}},passwordError)))),_react.default.createElement(_reactNative.View,{style:defaultStyles.rememberMeLoginRowWrapper,testID:'blui-login-remember-me-row-wrapper',__source:{fileName:_jsxFileName,lineNumber:295,columnNumber:17}},showRememberMe&&_react.default.createElement(_reactNative.View,{style:defaultStyles.rememberMeWrapper,testID:'blui-login-remember-me-wrapper',__source:{fileName:_jsxFileName,lineNumber:297,columnNumber:25}},_react.default.createElement(_reactNativePaper.Checkbox.Android,{status:rememberMe?'checked':'unchecked',onPress:function onPress(){return handleRememberMeChanged(!rememberMe);},testID:'blui-login-remember-me-checkbox',__source:{fileName:_jsxFileName,lineNumber:298,columnNumber:29}}),_react.default.createElement(_reactNativePaper.Text,{variant:"bodyLarge",testID:'blui-login-remember-me-login',style:defaultStyles.rememberMeText,__source:{fileName:_jsxFileName,lineNumber:303,columnNumber:29}},rememberMeLabel||'Remember Me')),_react.default.createElement(_reactNative.View,{style:[defaultStyles.loginButtonWrapper,{width:showRememberMe?'auto':'100%'}],testID:'blui-login-login-button-wrapper',__source:{fileName:_jsxFileName,lineNumber:312,columnNumber:21}},_react.default.createElement(_reactNativePaper.Button,{testID:'blui-login-login-button',onPress:handleLogin,disabled:!isFormValid(),mode:"contained",style:defaultStyles.loginButton,__source:{fileName:_jsxFileName,lineNumber:321,columnNumber:25}},loginButtonLabel||'Log In'))),showForgotPassword&&_react.default.createElement(_reactNative.View,{style:defaultStyles.forgotPasswordWrapper,testID:'blui-login-forgot-password-wrapper',__source:{fileName:_jsxFileName,lineNumber:334,columnNumber:21}},_react.default.createElement(_reactNativePaper.Text,{variant:"labelLarge",style:{color:theme.colors.primary},onPress:handleForgotPassword,testID:'blui-login-forgot-password-label',__source:{fileName:_jsxFileName,lineNumber:335,columnNumber:25}},forgotPasswordLabel||'Forgot your password?')),showSelfRegistration&&_react.default.createElement(_reactNative.View,{style:defaultStyles.selfRegisterWrapper,testID:'blui-login-self-register-wrapper',__source:{fileName:_jsxFileName,lineNumber:347,columnNumber:21}},_react.default.createElement(_reactNativePaper.Text,{variant:"bodyMedium",testID:'blui-login-self-register-instruction-label',__source:{fileName:_jsxFileName,lineNumber:348,columnNumber:25}},selfRegisterInstructions||'Need an account?'),_react.default.createElement(_reactNativePaper.Text,{variant:"labelLarge",style:{color:theme.colors.primary},onPress:handleSelfRegister,testID:'blui-login-self-register-label',__source:{fileName:_jsxFileName,lineNumber:351,columnNumber:25}},selfRegisterButtonLabel||'Register now!')),showContactSupport&&_react.default.createElement(_reactNative.View,{style:defaultStyles.contactSupportWrapper,testID:'blui-login-contact-support-wrapper',__source:{fileName:_jsxFileName,lineNumber:363,columnNumber:21}},_react.default.createElement(_reactNativePaper.Text,{variant:"labelLarge",style:{color:theme.colors.primary},onPress:handleContactSupport,testID:'blui-login-contact-support-label',__source:{fileName:_jsxFileName,lineNumber:364,columnNumber:25}},contactSupportLabel||'Contact Support')),_react.default.createElement(_reactNative.View,{style:defaultStyles.footerWrapper,__source:{fileName:_jsxFileName,lineNumber:375,columnNumber:17}},footer),showCyberSecurityBadge&&_react.default.createElement(_reactNative.View,{style:defaultStyles.cyberSecurityBadgeWrapper,testID:'blui-login-cyber-security-badge-wrapper',__source:{fileName:_jsxFileName,lineNumber:378,columnNumber:21}},_react.default.createElement(_reactNative.Image,{style:{width:'100%'},resizeMode:"contain",source:require('../../assets/images/cybersecurity_certified.png'),__source:{fileName:_jsxFileName,lineNumber:382,columnNumber:25}}))));};
//# sourceMappingURL=LoginScreenBase.js.map